import { useLayoutEffect, useState } from "react";
import ResizeObserver from "resize-observer-polyfill";
const zeroBounds = new DOMRect();
export default (cb) => {
    const [el, setEl] = useState(null);
    const [bounds, setBounds] = useState(zeroBounds);
    useLayoutEffect(() => {
        if (!el)
            return;
        const resizeObserver = new ResizeObserver(() => {
            const bounds = el.getBoundingClientRect();
            cb === null || cb === void 0 ? void 0 : cb(bounds);
            setBounds(bounds);
        });
        resizeObserver.observe(el);
        return () => {
            resizeObserver.disconnect();
        };
    }, [el]);
    return [setEl, bounds, el];
};
